'Wireless weather station prototype 
'Copyright 2007-2008 Raymond Allen
'Weather 3: Switching to all picture mode (need to download 57,600 bytes for each picture)
'Weather 4:  Adding Berlin webcams
'Weather 5:  Controlling buttons in completed package
'Weather 6:  Adding feedback to clear up transmission problems
'includes optional debugging text via serial connection with PropTerminal..

CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000
  '_clkfreq = 100_000_000        'Comment out this line if you don't have the 6.25 MHz crystal !!!

  vga_params = 21
  cols = 30
  rows = 15
  screensize = cols * rows

  SD_BasePin=0

    WMin  =       381  'minimum wait    

VAR

  long  vga_status      'status: off/visible/invisible  read-only       (21 contiguous longs)
  long  vga_enable      'enable: off/on                 write-only
  long  vga_pins        'pins: byte(2),topbit(3)        write-only
  long  vga_mode        'mode: interlace,hpol,vpol      write-only
  long  vga_videobase   'video base @word               write-only
  long  vga_colorbase   'color base @long               write-only              
  long  vga_hc          'horizontal cells               write-only
  long  vga_vc          'vertical cells                 write-only
  long  vga_hx          'horizontal cell expansion      write-only
  long  vga_vx          'vertical cell expansion        write-only
  long  vga_ho          'horizontal offset              write-only
  long  vga_vo          'vertical offset                write-only
  long  vga_hd          'horizontal display pixels      write-only
  long  vga_hf          'horizontal front-porch pixels  write-only
  long  vga_hs          'horizontal sync pixels         write-only
  long  vga_hb          'horizontal back-porch pixels   write-only
  long  vga_vd          'vertical display lines         write-only
  long  vga_vf          'vertical front-porch lines     write-only
  long  vga_vs          'vertical sync lines            write-only
  long  vga_vb          'vertical back-porch lines      write-only
  long  vga_rate        'pixel rate (Hz)                write-only

  word  screen[screensize]

  long  col, row, color, flag
  long  boxcolor,ptr
  long  stack[100]

  byte JBBuffer[360]

OBJ

  'vga : "vga"
  'Juice : "Juice_Driver1"
  ser :  "FullDuplexSerialExtendedA"       'for bigger buffer
  sdfat: "fsrw"
  text: "PC_Text"  'Prop Terminal   



PUB begin|i,j,nscreen,rx,bn,acnt,k


  'Juice.Start(0, @screen, @vgacolors, cols, rows)     '(SD_BasePin, pscreen, pvga_colorbase, ncols, nrows)  

  ser.start(20, 19, 0, 115200)

  text.start(30)
  text.str(string("Hello"))

    'using LEDs on PINS P14,P15 to monitor status
   'dira[14]~~
   dira[15]~~
   dira[8]~~

  


   'Show First Image
  PauseMsec(8000)
  PushButton(12)  'next
  PauseMsec(300)
  PushButton(10)  'play

  acnt:=cnt
   
  repeat
    if (cnt-acnt)> (clkfreq*6)
      'show next image
      ShowNext
      acnt:=cnt
    outa[15]~  'turn off write indicator
    outa[8]~  'turn off write indicator      
    if (ser.rxcheck=="!")
      PauseMSec(10)  
      if (ser.rxcheck=="#")
        PauseMSec(10)
        rx:=ser.rxcheck
        if (rx=="$")
          'PC wants to send us an updated picture
          'First, show next image to maximize our time
          ShowNext
          acnt:=cnt
          'Then, get image
          GetPicture
          PushButton(10)  'play   (in case went to sleep)
        elseif (rx=="@")
          'PC wants us to push Juicebox button
          bn:=ser.rx
          case bn
            9..13:
              PushButton(bn)
           
          
            

  'Use Hyperterminal to send over characters at 4800 baud over PropPlug
  row:=0
  col:=0
  ser.start(20, 30, 0, 115200)
  repeat
    i:=ser.rxcheck
    if (i>0)
      'hex(i,3)
      'print(" ")
     print(i)

PRI ShowNext
  'show next image
  PushButton(12)
  text.str(string(13,"Next."))
  PauseMsec(500) 'give JB a second to load image from SD
   

PRI GetPicture|k,nscreen,j,r
  'PC transmitting .jbp image
  outa[15]~~  'turn on Prop SD write indicator
  outa[8]~~   'turn on Prop SD write indicator
 
  'Give the Go word..
  ser.tx("G")
  ser.tx("o")
  text.str(string(13,"Go"))
 
  sdfat.mount(SD_BasePin) 'start the SD driver
  'give assembly a moment to load
  waitcnt(cnt+10000)
   
  nscreen:=ser.rxtime(1000)  'get screen #
  if nscreen<"1"  or nscreen>"4"
    sdfat.stop
    text.str(string(13,"Invalid screen #"))
    text.out(nscreen)
    return  'failure by invalid screen #
  ser.rxflush  
  ser.tx("X")  'Input buffer ready 
  byte[@sFilename+4]:=nscreen
  sdfat.popen(@sFilename, "w")     'open the file
 
  repeat k from 0 to 159
    outa[15]~  'turn off write indicator
    outa[8]~   'turn off write indicator
    JBBuffer[0]:=ser.rxtime(1000)  
    repeat j from 1 to 359                    
      JBBuffer[j]:=ser.rxtime(100)
      'if (r<0)
      '  text.str(string(13,"Missing screen data"))  
      '  RecoverScreen(k)        
      '  return
      'else
      '  JBBuffer[j]:=r
    outa[15]~~  'turn on Prop SD write indicator
    outa[8]~~   'turn on Prop SD write indicator
    ser.rxflush
    ser.tx("X") 'input buffer ready
    sdfat.pwrite(@JBBuffer,360)
   
    
  sdfat.pclose
  sdfat.stop        'stop the SD driver so it doesn't interfere with the JuiceBox
  'Tell PC we're done
  ser.tx("L")
  ser.tx(255)
  text.str(string(13,"Done."))
  
PRI RecoverScreen(i)|k
  'fill in missing data
  repeat k from i to 159
    sdfat.pwrite(@JBBuffer,360)
  sdfat.pclose
  sdfat.stop        'stop the SD driver so it doesn't interfere with the JuiceBox
  text.str(string(13,"Recovered."))

PRI PushButton(bn)
    'Push Juicebox button
    dira[bn]~~
    outa[bn]~  'tie to ground through 33 ohm resistor
    PauseMsec(100) 'wait
    dira[bn]~  'return to high impedance
    text.str(string(13,"Pushed Button:"))
    text.dec(bn)

PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    print("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      print(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      print("0")
    i /= 10


PUB hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    print(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
    
 
PUB start(pins)

  print($100)
  longmove(@vga_status, @vgaparams, vga_params)
  vga_pins := pins
  vga_videobase := @screen
  vga_colorbase := @vgacolors
  'result := vga.start(@vga_status)


'' Stop terminal - frees a cog

PUB stop

  'vga.stop

'' Draw a box

PUB box(left,top,width,height) | x, y, i

  ptr := top * cols + left
  boxchr($0)
  repeat i from 1 to width
    boxchr($C)
  boxchr($8)
  repeat i from 1 to height
    ptr := (top + i) * cols + left
    boxchr($A)
    ptr += width
    boxchr($B)
  ptr := (top + height + 1) * cols + left
  boxchr($1)
  repeat i from 1 to width
    boxchr($D)
  boxchr($9)

PRI boxchr(c): i

  screen[ptr++] := boxcolor << 10 + $200 + c

  

'' Print a character
''
''  $00..$FF = character
''      $100 = clear screen
''      $108 = backspace
''      $10D = new line
''$110..$11F = select color

PUB print(c) | i, k

  case c
    $0A..$FF:           'character?
      k := color << 1 + c & 1
      i := k << 10 + $200 + c & $FE
      screen[row * cols + col] := i
      if (row+1)<rows
        screen[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $00:               'clear screen?
      wordfill(@screen, $220, screensize)
      col := row := 0

    $08:               'backspace?
      if col
        col--

    $0D:               'return?
      newline

    $110..$11F:         'select color?
      color := c & $F


' New line

PRI newline : i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
'      wordmove(@screen[i*cols], @screen[(i+2)*cols], cols)
    'clear new line
'    wordfill(@screen[(rows-2)*cols], $200, cols<<1)


' Data
PUB out(c) | i, k

'' Output a character
''
''     $00 = clear screen
''     $01 = home
''     $08 = backspace
''     $09 = tab (8 spaces per)
''     $0A = set X position (X follows)
''     $0B = set Y position (Y follows)
''     $0C = set color (color follows)
''     $0D = return
''  others = printable characters

  case flag
    $00: case c
           $00: wordfill(@screen, $220, screensize)
                col := row := 0
           $01: col := row := 0
           $08: if col
                  col--
           $09: repeat
                  print(" ")
                while col & 7
           $0A..$0C: flag := c
                     return
           $0D: newline
           other: print(c)
    $0A: col := c // cols
    $0B: row := c // rows
    $0C: color := c & 7
  flag := 0
  
PUB PauseMSec(Duration)
{{Pause execution in milliseconds.
  PARAMETERS: Duration = number of milliseconds to delay.
}}
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> WMin) + cnt) 
DAT
sFilename byte  "Prop1.JBP"


vgaparams               long    0               'status
                        long    1               'enable
                        long    %010_111        'pins
                        long    %011            'mode
                        long    0               'videobase
                        long    0               'colorbase
                        long    cols            'hc
                        long    rows            'vc
                        long    1               'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    512             'hd
                        long    16              'hf
                        long    96              'hs
                        long    48              'hb
                        long    380             'vd
                        long    11              'vf
                        long    2               'vs
                        long    31              'vb
                        long    20_000_000      'rate

vgacolors               long
                        long    $C000C000       'red
                        long    $C0C00000
                        long    $08A808A8       'green
                        long    $0808A8A8
                        long    $50005000       'blue
                        long    $50500000
                        long    $FC00FC00       'white
                        long    $FCFC0000
                        long    $FF80FF80       'red/white
                        long    $FFFF8080
                        long    $FF20FF20       'green/white
                        long    $FFFF2020
                        long    $FF28FF28       'cyan/white
                        long    $FFFF2828
                        long    $00A800A8       'grey/black
                        long    $0000A8A8
                        long    $C0408080       'redbox
spcl                    long    $30100020       'greenbox
                        long    $3C142828       'cyanbox
                        long    $FC54A8A8       'greybox
                        long    $3C14FF28       'cyanbox+underscore
                        long    0

altscreen               byte    $15,$6E,$20,$14,$20,$B1,$6D,$16,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5F,$5F,$5F,$5F,$5F,$20
                        byte    $20,$81,$82,$86,$87,$8B,$80,$8b,$80,$8B,$20,$20,$AF,$BD,$BE,$9B,$7F,$9B,$A6,$A8,$AA,$20,$20,$17,$20,$20,$53,$54,$41,$52,$54,$20
                        byte    $20,$20,$20,$20,$20,$20,$20,$20,$20,$17,$20,$20,$20,$20,$20,$AC,$20,$AC,$20,$20,$20,$20,$1D,$1E,$20,$20,$20,$20,$20,$20,$20,$20
                        byte    $20,$20,$42,$49,$41,$53,$20,$A0,$1A,$1B,$20,$20,$20,$20,$20,$18,$20,$18,$20,$20,$20,$20,$20,$91,$20,$23,$24,$38,$30,$30,$30,$20
                        byte    $3A,$3D,$20,$20,$20,$20,$20,$20,$20,$99,$BB,$20,$56,$62,$20,$20,$20,$20,$20,$20,$20,$20,$20,$BC,$20,$23,$25,$31,$30,$30,$31,$20
                        byte    $20,$50,$30,$20,$BA,$BB,$90,$94,$20,$B6,$20,$31,$30,$30,$6B,$13,$20,$17,$20,$20,$20,$20,$20,$18,$20,$70,$5B,$69,$5D,$20,$20,$20
                        byte    $20,$20,$20,$20,$20,$20,$20,$20,$20,$18,$20,$20,$20,$20,$20,$20,$AB,$AC,$AD,$31,$30,$B5,$46,$20,$20,$20,$20,$20,$20,$20,$20,$20
                        byte    $12,$10,$13,$41,$2F,$44,$20,$20,$20,$20,$58,$B2,$2D,$20,$31,$20,$20,$18,$20,$20,$20,$20,$20,$20,$63,$61,$74,$5F,$64,$6F,$70,$65